

#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| External Variables                                               |
//+------------------------------------------------------------------+

extern int    Magic           = 999;
extern double Lots            = 0.33;
extern int NumPos = 3;                 //Number of Positions to Open
extern bool   MoneyManagement = false;
extern int    UseFreeMargin   = 3;
extern int    AccountType     = 3;
extern int    Leverage        = 200;
extern bool   StartUp         = false;

//+------------------------------------------------------------------+
//| Internal variables                                               |
//+------------------------------------------------------------------+

int    PricePerPip;
double DecimalCorrection;
int    DecimalPlaces;
double MaxLots;

bool   OKToTrade;
int    i;
int    OpenOrders;

double ACSignalCurrent30;
double ACSignalCurrent240;
double ACSignalCurrent60;

double ACSignalPrevious30;
double ACSignalPrevious240;
double ACSignalPrevious60;

double StochasticSignalPrev30;
double StochasticSignalPrev240;
double StochasticSignalPrev60;

double StochasticSignalCurr30;
double StochasticSignalCurr240;
double StochasticSignalCurr60;

double StochasticLower;
double StochasticUpper;

double AwsomeCurr;
double AwsomePrev;

bool   BuyFlag;
bool   SellFlag;
bool   StopLossAdjust;

// Simple Moving Average settings

extern bool UseSMAFilter = false;
extern int MAPeriod = 0;
double SMA200;
int SMA200Flag;

// TrailingStop settings

extern bool UseTS = false;
int TSTicket;
int TSIndex = 1;
extern int TS = 50;

// Targetprofit settings

extern int    TP1 = 0;

// StopLoss Settings

extern int    SL  = 0;
extern int Safety = 30;

// Last Position Open End
extern bool LastStop = false;

int    slippage = 10;

double TSPrice;

double EntryPrice;
extern bool UseArizcatMod = false;
double ArizcatLot;
bool ArizcatFlag = False;

extern bool UseAlert = true;
extern bool UseSendMail = true;
bool IsOpen = true;
int init()
{
   if (UseArizcatMod)
   {
      SL = SL /2;
   }
}
//+------------------------------------------------------------------+
//| Main code                                                        |
//+------------------------------------------------------------------+

int start()
{

   

   //+---------------------------------------------------------------+
   //| Account Type Initiasation                                     |
   //+---------------------------------------------------------------+
   StochasticUpper = 50 - Safety;
   StochasticLower = 50 + Safety;

   if (AccountType==0)
   {
      PricePerPip       = 10;
      DecimalCorrection = 0.5;
      DecimalPlaces     = 0;
   }
   
   if (AccountType==1)
   { 
      PricePerPip       = 10;
      DecimalCorrection = 0.05;
      DecimalPlaces     = 1;
   }
   
   if (AccountType==2)
   {
      PricePerPip       = 10;
      DecimalCorrection = 0.005;
      DecimalPlaces     = 2;
   }
   
   if (AccountType==3)
   {
      PricePerPip       = 1;
      DecimalCorrection = 0.005;
      DecimalPlaces     = 2;
   }
   
   //+---------------------------------------------------------------+
   //| Money Management Routine                                      |
   //+---------------------------------------------------------------+

   if (MoneyManagement)
   {
      if (UseFreeMargin > 100)
      {
         Comment("ERROR: UseFreeMargin value too large.");
         OKToTrade=false;
      }
      else
      {
         if (UseFreeMargin < 1)
         {
            Comment("ERROR: UseFreeMargin value too small.");
            OKToTrade=false;
         }
         else
         {
            Lots=NormalizeDouble(((AccountFreeMargin()*(UseFreeMargin/NumPos)*Leverage)/
               (Ask*PricePerPip*1000000))-DecimalCorrection,DecimalPlaces);
            
            OKToTrade=true;
         }
      }
   }
   else
   {
      MaxLots=NormalizeDouble(((AccountFreeMargin()*20*Leverage)/
         (Ask*PricePerPip*1000000))-DecimalCorrection,DecimalPlaces);
      if (Lots > MaxLots)
      {
         Comment("ERROR: Insufficient Free Margin.\nLower Lots value or use MoneyManagement.");
         OKToTrade=false;
      }
      else
      {
         OKToTrade=true;
      }
   }

   //+---------------------------------------------------------------+
   //| Time Frame Check                                              |
   //+---------------------------------------------------------------+
   
  /*if (Period() != 60)
   {
      OKToTrade=false;
      Comment("Wrong Time Frame. Please switch to D1.");
   }*/
   
   //+---------------------------------------------------------------+
   //| Start-Up Routine (To Prevent Immediate Entry During Start-Up) |
   //+---------------------------------------------------------------+

   if (StartUp)
   {
         if (Hour()==0)
         {
            OKToTrade = true;
            StartUp   = false;
         }
         else
         {
            OKToTrade = false;
            StartUp   = true;
            Comment("Staring Up Delay. Awaiting Next Candle.");
         }
      
   }

   //+---------------------------------------------------------------+
   //| Main Trading Routine                                          |
   //+---------------------------------------------------------------+

   if (OKToTrade)
   {

      //+------------------------------------------------------------+
      //| Signal & Indicators                                        |
      //+------------------------------------------------------------+

      ACSignalCurrent30  = iAC(NULL,30,0);
      ACSignalCurrent240  = iAC(NULL,240,0);
      ACSignalCurrent60  = iAC(NULL,60,0);
      
      ACSignalPrevious30 = iAC(NULL,30,1);
      ACSignalPrevious240 = iAC(NULL,240,1);
      ACSignalPrevious60 = iAC(NULL,60,1);
      
      StochasticSignalCurr30 = iStochastic(NULL,30,5,3,4,MODE_SMA,0,MODE_SIGNAL,0);
      StochasticSignalCurr240 = iStochastic(NULL,240,5,3,4,MODE_SMA,0,MODE_SIGNAL,0);
      StochasticSignalCurr60 = iStochastic(NULL,60,5,3,4,MODE_SMA,0,MODE_SIGNAL,0);

      

      StochasticSignalPrev240 = iStochastic(NULL,240,5,3,4,MODE_SMA,0,MODE_SIGNAL,1);
      StochasticSignalPrev60 = iStochastic(NULL,60,5,3,4,MODE_SMA,0,MODE_SIGNAL,1);
      StochasticSignalPrev30 = iStochastic(NULL,30,5,3,4,MODE_SMA,0,MODE_MAIN,1);
      
      AwsomeCurr = iAO(NULL,240,0);
      AwsomePrev = iAO(NULL,240,1);
      
      
      SMA200           = iMA(NULL,240,MAPeriod,0,MODE_SMA,PRICE_CLOSE,0);              

      // SMA200 Options: PRICE_CLOSE, PRICE_OPEN, PRICE_HIGH, PRICE_LOW, 
      //                 PRICE_MEDIAN, PRICE_TYPICAL, PRICE_WEIGHTED
      
      if (SMA200 >= Open[0]) 
      {
         SMA200Flag = -1;
      } else
      {
         SMA200Flag = 1;
      }
      
      // dynamic takeprofit value
        // TP1 = ((iMA(NULL, 240, 5, 0, MODE_SMA, PRICE_HIGH, 0) - iMA(NULL, 240, 5, 0, MODE_SMA, PRICE_LOW, 0)) / Point);
         //SL = ((iMA(NULL, 240, 20, 0, MODE_SMA, PRICE_HIGH, 0) - iMA(NULL, 240, 20, 0, MODE_SMA, PRICE_LOW, 0)) / Point);
         //TS = ((iMA(NULL, 60, 3, 0, MODE_SMA, PRICE_HIGH, 0) - iMA(NULL, 60, 3, 0, MODE_SMA, PRICE_LOW, 0)) / Point);  
      Comment("nLots = ",Lots
           ,"\nNum. of Pos. = ", NumPos
           ,"\nDyn TP = ", TP1
           ,"\nDyn SL = ", SL
           ,"\nDyn TS = ", TS
           );

      //+------------------------------------------------------------+
      //| Check Condition To Open Long                               |
      //+------------------------------------------------------------+


      if (
        ACSignalCurrent240> ACSignalPrevious240
      && iAO(NULL, 240, 0) > iAO(NULL, 240, 1)
      && StochasticSignalCurr240 > StochasticSignalPrev240
      && StochasticSignalCurr240 > StochasticUpper 
      && StochasticSignalCurr30 > StochasticSignalPrev30
      && BuyFlag==false)
      {
      
        
               
         if (IsOpen)
         {
            if (!ArizcatFlag)
            {
               for(i=0;i<=OrdersTotal();i++)   
               {
                  OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
                  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	               {
	                 if (OrderOpenPrice()>= Ask)
	                 {			
                        OrderClose(OrderTicket(),OrderLots(),Ask,slippage,CLR_NONE);
                    }
                  }
            
               }
            }
         SellFlag=false;
         
         
         if (UseSMAFilter == true && Ask>SMA200)
         {
            
            if (NumPos == 1)
            {
               if (LastStop == false)
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,0,"OzFx-5B",Magic,CLR_NONE);
               } else
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,Ask+(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
               }
               
            } else
            {
               for (i=1; i<=NumPos-1;i++)
               {
                  OrderSend(Symbol(), OP_BUY, Lots, Ask, slippage, Ask-SL*Point, Ask+(TP1*i)*Point, "OzFx-Buy", Magic, CLR_NONE);
               }
               if (LastStop == false)
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,0,"OzFx-5B",Magic,CLR_NONE);
               } else
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,Ask+(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
               }
            }
            if (UseSendMail) SendMail("New trade", "Buy " + Symbol());
            if (UseAlert) Alert("Buy ", Symbol());
            ArizcatLot = Lots;
            EntryPrice=Ask;         
            BuyFlag=true;
            StopLossAdjust=false;
            IsOpen = false;
         } 
         if (UseSMAFilter == false)
         {
           if (NumPos == 1)
            {
               if (LastStop == false)
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,0,"OzFx-5B",Magic,CLR_NONE);
               } else
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,Ask+(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
               }
            } else
            {
               for (i=1; i<=NumPos-1;i++)
               {
                  OrderSend(Symbol(), OP_BUY, Lots, Ask, slippage, Ask-SL*Point, Ask+(TP1*i)*Point, "OzFx-Buy", Magic, CLR_NONE);
               }
               if (LastStop == false)
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,0,"OzFx-5B",Magic,CLR_NONE);
               } else
               {
                  OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-SL*Point,Ask+(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
               }
            }
            if (UseSendMail) SendMail("New trade", "Buy " + Symbol());
            if (UseAlert) Alert("Buy ", Symbol()); 
            ArizcatLot = Lots;
            EntryPrice=Ask;         
            BuyFlag=true;
            StopLossAdjust=false;
            IsOpen = false;
          }
          } else
          {
            //
           }
         
      }

      //+------------------------------------------------------------+
      //| Check Condition To Open Short                              |
      //+------------------------------------------------------------+


      if (
         ACSignalCurrent240< ACSignalPrevious240
      && iAO(NULL, 240, 0) < iAO(NULL, 240, 1)
      && StochasticSignalCurr240 < StochasticSignalPrev240 
      && StochasticSignalCurr240 < StochasticLower
      && StochasticSignalCurr30 < StochasticSignalPrev30
      && SellFlag==false)
      
      {
      
         // dynamic takeprofit value
         
       if (IsOpen)
       { 
         if (!ArizcatFlag)
         {
         for(i=0;i<=OrdersTotal();i++)   
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
            {
               if (OrderOpenPrice() <= Bid)
               {				
                  OrderClose(OrderTicket(),OrderLots(),Bid,slippage,CLR_NONE);
               }
            }
         
         } 
         }
         BuyFlag=false;
         
         if (UseSMAFilter == true && Bid<SMA200)
         {
            if (NumPos == 1)
               {
                  if (LastStop == false)
                  {
                     OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,0,"OzFx-Sell",Magic,CLR_NONE);
                  } else
                  {
                     OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,Bid-(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
                  }
               } else
               {
                  for (i=1; i<=NumPos-1;i++)
                  {
                     OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,Bid-(TP1*i)*Point,"OzFx-1S",Magic,CLR_NONE);
                  }
                  if (LastStop == false)
                  {
                     OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,0,"OzFx-Sell",Magic,CLR_NONE);
                  } else
                  {
                     OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,Bid-(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
                  }
               }
               if (UseSendMail) SendMail("New trade", "Sell " + Symbol());
               if (UseAlert) Alert("Sell ", Symbol());
            ArizcatLot = Lots;
            EntryPrice=Bid;
            SellFlag=true;
            StopLossAdjust=false;
            IsOpen = false;
          }
          if (UseSMAFilter == false) 
          {
            if (NumPos == 1)
            {
               if (LastStop == false)
               {
                  OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,0,"OzFx-Sell",Magic,CLR_NONE);
               } else
               {
                  OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,Bid-(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
               }
            } else
            {
               for (i=1; i<=NumPos-1;i++)
               {
                  OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,Bid-(TP1*i)*Point,"OzFx-1S",Magic,CLR_NONE);
               }
               if (LastStop == false)
               {
                  OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,0,"OzFx-Sell",Magic,CLR_NONE);
               } else
               {
                  OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+SL*Point,Bid-(TP1*NumPos)*Point,"OzFx-5B",Magic,CLR_NONE);
               }
            }
            if (UseSendMail) SendMail("New trade", "Sell " + Symbol());
            if (UseAlert) Alert("Sell ", Symbol());
            ArizcatLot = Lots;
            EntryPrice=Bid;
            SellFlag=true;
            StopLossAdjust=false;
            IsOpen = false;
           }
         } else
          {
            //
           }
      }

      //+------------------------------------------------------------+
      //| If Trade one hit TakeProfit, move StopLoss to BreakEven    |
      //+------------------------------------------------------------+

      if (StopLossAdjust==false)
      {
         if ((BuyFlag && Bid>=EntryPrice+TP1*Point) || (SellFlag && Ask<=EntryPrice-TP1*Point))
         {
         for(i=0;i<OrdersTotal();i++)   
         {
            if (UseTS)
            {
               OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES);
               if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
               {				
                  OrderModify(OrderTicket(),OrderOpenPrice(),EntryPrice,OrderTakeProfit(),0,Magenta);   
               }
            } else
            {
              OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
              if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
              {
                  if (BuyFlag)				
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),EntryPrice+((MarketInfo(Symbol(), MODE_SPREAD)+3)*Point),OrderTakeProfit(),0,Magenta);   
                  }
                  if (SellFlag)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),EntryPrice-((MarketInfo(Symbol(), MODE_SPREAD)+3)*Point),OrderTakeProfit(),0,Magenta); 
                  }
               }
            } 
         }
            StopLossAdjust=true;
         }
      }
      
      //+------------------------------------------------------------+
      //| Set TrailingStops    |
      //+------------------------------------------------------------+
      if (UseTS)
      {
         if ((BuyFlag && Bid>=EntryPrice+(TS*(TSIndex+1))*Point) || (SellFlag && Ask<=EntryPrice-(TS*(TSIndex+1))*Point))
         {
            if (BuyFlag)
            {
               TSPrice = EntryPrice+(TS*TSIndex)*Point;
            }
            if (SellFlag)
            {
               TSPrice = EntryPrice-(TS*TSIndex)*Point;
            }
         for(i=0;i<OrdersTotal();i++)   
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
            {				
               OrderModify(OrderTicket(),OrderOpenPrice(),TSPrice,OrderTakeProfit(),0,Magenta);
            }
         }
         TSIndex = TSIndex + 1; 
         }
      }
      
      if (UseArizcatMod)
      {
         if ((BuyFlag && Bid<=EntryPrice-SL*Point) || (SellFlag && Ask>=EntryPrice+SL*Point))
         {
            if (BuyFlag)
            {
               OrderSend(Symbol(),OP_SELL,ArizcatLot*NumPos,Bid,slippage,Bid+SL*Point,Bid-SL*Point,"OzFx-Sell",Magic,CLR_NONE);
             BuyFlag = false;
             ArizcatFlag = True;  
            }
            if (SellFlag)
            {
               OrderSend(Symbol(),OP_BUY,ArizcatLot*NumPos,Ask,slippage,Ask-SL*Point,Ask+SL*Point,"OzFx-Sell",Magic,CLR_NONE);
               SellFlag = False;
               ArizcatFlag = True;
            }

         }
      }
         
   }

   //+---------------------------------------------------------------+
   //| Reset sequence if all open orders have been closed            |
   //+---------------------------------------------------------------+

   OpenOrders=0;
   for(i=0;i<OrdersTotal();i++)   
   {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   } 

   if (OpenOrders==0)
   {
      BuyFlag=false;
      SellFlag=false;
      StopLossAdjust=false;
      TSIndex = 1;
      StartUp = false;
      ArizcatFlag = false;
      IsOpen = true;
   }

   return(0);
}